<?php

namespace App\Controllers\Tarifas\Acabados;

use App\Controllers\BaseResourceController;
use App\Entities\Tarifas\Acabados\TarifaAcabadoEntity;
use App\Models\Collection;
use App\Models\Tarifas\Acabados\TarifaAcabadoModel;

use App\Models\Compras\ProveedorModel;
use App\Models\Compras\ProveedorTipoModel;


class TarifaAcabados extends BaseResourceController
{

    protected $modelName = TarifaAcabadoModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Tarifa Acabado';
    protected static $singularObjectNameCc = 'tarifaAcabado';
    protected static $pluralObjectName = 'Tarifas Acabado';
    protected static $pluralObjectNameCc = 'tarifasAcabado';

    protected static $controllerSlug = 'tarifasacabado';

    protected static $viewPath =  'themes/vuexy/form/tarifas/acabado/';

    protected $indexRoute = 'tarifaAcabadoList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('Tarifaacabado.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;

        $this->viewData = ['usingServerSideDataTable' => true];

        // Breadcrumbs 
        $this->viewData['breadcrumb'] = [
            ['title' => lang("App.menu_tarifas"), 'route' => "javascript:void(0);", 'active' => false],
            ['title' => lang("App.menu_tarifaacabado"), 'route' => site_url('tarifas/acabados'), 'active' => true]
        ];

        parent::initController($request, $response, $logger);
    }


    public function index()
    {

        checkPermission('tarifa-acabado.menu');

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('Tarifaacabado.tarifaacabado')]),
            'tarifaacabadoEntity' => new TarifaAcabadoEntity(),
            'usingServerSideDataTable' => true,
        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewTarifaAcabadoList', $viewData);
    }


    public function add()
    {

        checkPermission('tarifa-acabado.create', $this->indexRoute);

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            $sanitizedData['user_created_id'] = auth()->user()->id;

            if ($this->request->getPost('mostrar_en_presupuesto') == null) {
                $sanitizedData['mostrar_en_presupuesto'] = false;
            }

            if ($this->request->getPost('acabado_cubierta') == null) {
                $sanitizedData['acabado_cubierta'] = false;
            }

            if ($this->request->getPost('acabado_sobrecubierta') == null) {
                $sanitizedData['acabado_sobrecubierta'] = false;
            }

            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult) :

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(site_url('/tarifas/acabados/edit/' . $id))->with('message', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['proveedores'] = $this->getProveedores();

        $this->viewData['tarifaacabadoEntity'] = isset($sanitizedData) ? new TarifaAcabadoEntity($sanitizedData) : new TarifaAcabadoEntity();
        $this->viewData['formAction'] = route_to('tarifaAcabadoAdd');
        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('Tarifaacabado.moduleTitle') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null)
    {

        checkPermission('tarifa-acabado.edit', $this->indexRoute);

        if ($requestedId == null) :
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $tarifaacabadoEntity = $this->model->find($id);

        if ($tarifaacabadoEntity == false) :
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('Tarifaacabado.tarifaacabado')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            $sanitizedData['user_updated_id'] = auth()->user()->id;

            if ($this->request->getPost('mostrar_en_presupuesto') == null) {
                $sanitizedData['mostrar_en_presupuesto'] = false;
            }

            if ($this->request->getPost('acabado_cubierta') == null) {
                $sanitizedData['acabado_cubierta'] = false;
            }

            if ($this->request->getPost('acabado_sobrecubierta') == null) {
                $sanitizedData['acabado_sobrecubierta'] = false;
            }


            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('Tarifaacabado.tarifaacabado'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $tarifaacabadoEntity->fill($sanitizedData);

                $thenRedirect = false;
            endif;

            if ($noException && $successfulResult) :
                $id = $tarifaacabadoEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaacabadoEntity'] = $tarifaacabadoEntity;
        $this->viewData['proveedores'] = $this->getProveedores();

        $this->viewData['formAction'] = route_to('updateTarifaAcabado', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('Tarifaacabado.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function datatable()
    {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns'])) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable([], 0, 0, $errstr), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $search = $reqData['search']['value'];
            $requestedOrder = $reqData['order']['0']['column'] ?? 1;
            $order = TarifaAcabadoModel::SORTABLE[$requestedOrder >= 0 ? $requestedOrder : 1];
            $dir = $reqData['order']['0']['dir'] ?? 'asc';

            $resourceData = $this->model->getResource($search)->orderBy($order, $dir)->limit($length, $start)->get()->getResultObject();

            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($search)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', nombre', 'nombre', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->nombre = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'nombre'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    private function getProveedores()
    {
        $provTipoModel = new ProveedorTipoModel();
        $provModel = new ProveedorModel();

        $tipoId = $provTipoModel->getTipoId("Acabados");
        return $provModel->getProvList($tipoId);
    }
    public function show_select()
    {
        $query =  $this->model->builder()
            ->select(
                ["id", "nombre as name", "code as description"]
            )
            ->where("deleted_at",null);
        if ($this->request->getGet("q")) {
            $query->groupStart()
                ->orLike("nombre", $this->request->getGet("q"))
                ->groupEnd();
        }
        return $this->response->setJSON($query->get()->getResultObject());
    }

    public function getSelect2()
    {
        if ($this->request->isAJAX()) {
            $query = $this->model->builder()->select(
                [
                    "id",
                    "nombre as name"
                ]
            )->where("deleted_at", null);
            if ($this->request->getGet("q")) {
                $query->groupStart()
                    ->orLike("lg_tarifa_acabado.nombre", $this->request->getGet("q"))
                    ->groupEnd();
            }

            return $this->response->setJSON($query->get()->getResultObject());
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }
}
